#! ruby
require 'phi'
require 'webbrowser'
class BrowserForm < Phi::Form
  def initialize
    self.font.name = "Terminal"
    self.font.size = 14
    self.font.style = [Phi::FS_BOLD]

    Phi::Edit.new(self, :ed_uri) do
      self.align = Phi::AL_TOP
    end

    Phi::WebBrowser.new(self, :wb) do
      self.align = Phi::AL_CLIENT
    end
=begin
    wb.on_command_state_change = proc do |sender, command, enable|
      case command
      when 1  # CSC_NAVIGATEFORWARD
        btn_forward.enabled = enable
      when 2  # CSC_NAGIGATEBACK
        btn_back.enabled = enable
      end
    end
=end
    wb.on_title_change = proc do |sender, text|
      self.caption = text
    end

    ed_uri.on_key_down = proc do |sender, key, shift|
      #p [:on_key_down, sender, key, shift]
      if key == 116  # [F5]
        wb.refresh
        return 0
      end
      key
    end
    ed_uri.on_key_press = proc do |sender, key|
      #p [:on_key_press, sender, key]
      if key == 0x0d
        wb.navigate2(ed_uri.text)
        return 0
      end
      key
    end

  end

  def location=(location)
    ed_uri.text = location
  end

  def navigate
    wb.navigate2(ed_uri.text)
  end

end
=begin
btn_back.on_click = proc do |sender|
  wb.go_back
end

btn_forward.on_click = proc do |sender|
  wb.go_forward
end

btn_home.on_click = proc do |sender|
  wb.go_home
end

btn_go.on_click = proc do |sender|
  wb.navigate2(ed_uri.text)
end
=end
if __FILE__ == $0
  form = BrowserForm.new
  form.show
  Phi.mainloop
end
